<script>
  import {
    GeoJSONSource,
    VectorSource,
    Layer,
    context
  } from "@jailbreak-paris/svelte-mapbox-gl";
  import { selection } from "_src/stores.js";

  export let data;

  const componentMap = {
    geojson: GeoJSONSource,
    vector: VectorSource
  };

  const defaultSourceProps = {};

  const paint = {
    "circle-color": [
      "case",
      ["boolean", ["feature-state", "selected"], false],
      "red",
      "#11b4da"
    ],
    "circle-radius": [
      "case",
      ["boolean", ["feature-state", "selected"], false],
      6,
      4
    ],
    "circle-stroke-width": 1,
    "circle-stroke-color": "#fff"
  };

  const { map } = context.getMapContext();

  function setCursor(name) {
    map.getCanvas().style.cursor = name;
  }

  function selectFeature({ detail }) {
    const { event, sourceId } = detail;
    const feature = event.features[0];
    $selection = { feature, sourceId };
  }
</script>

{#each data as { id, type, url, visible, sourceProps } (id)}
  {#if visible}
    <svelte:component
      this={componentMap[type]}
      {id}
      data={url}
      {...{ ...(defaultSourceProps[type] || {}), ...sourceProps }}>
      <Layer
        type="circle"
        {paint}
        on:mouseenter={() => setCursor('pointer')}
        on:mouseleave={() => setCursor('')}
        on:click={selectFeature} />
    </svelte:component>
  {/if}
{/each}
